#include <MD_MAX72xx.h>
#define  DEBUG  1
#if  DEBUG
#define PRINT(s, x) { Serial.print(F(s)); Serial.print(x); }
#define PRINTS(x) Serial.print(F(x))
#define PRINTD(x) Serial.println(x, DEC)
#else
#define PRINT(s, x)
#define PRINTS(x)
#define PRINTD(x)
#endif
#define HARDWARE_TYPE MD_MAX72XX::FC16_HW
#define MAX_DEVICES	1
#define CLK_PIN   13  // or SCK
#define DATA_PIN  11  // or MOSI
#define CS_PIN    10  // or SS
MD_MAX72XX mx = MD_MAX72XX(HARDWARE_TYPE, CS_PIN, MAX_DEVICES);

#define  DELAYTIME  100  // in milliseconds

const int blue = 2;
const int white = 3;
const int green = 4;
const int red = 5;
const int yellow = 6;
int blueState = 0;
int whiteState = 0;
int greenState = 0;
int redState = 0;
int yellowState = 0;

void scrollText(const char *p)
{
  uint8_t charWidth;
  uint8_t cBuf[8];  // this should be ok for all built-in fonts

  PRINTS("\nScrolling text");
  mx.clear();

  while (*p != '\0')
  {
    charWidth = mx.getChar(*p++, sizeof(cBuf) / sizeof(cBuf[0]), cBuf);

    for (uint8_t i=0; i<=charWidth; i++)	// allow space between characters
    {
      mx.transform(MD_MAX72XX::TSL);
      mx.setColumn(0, (i < charWidth) ? cBuf[i] : 0); 
      delay(DELAYTIME);
    }
  }
}


void setup()
{
  pinMode(blue, INPUT);
  pinMode(white, INPUT);
  pinMode(green, INPUT);
  pinMode(red, INPUT);
  pinMode(yellow, INPUT);
#if  DEBUG
  Serial.begin(57600);
#endif
  PRINTS("\n[MD_MAX72XX Test & Demo]");

  if (!mx.begin())
    PRINTS("\nMD_MAX72XX initialization failed");
}

void loop()
{
  blueState = digitalRead(blue);
  whiteState = digitalRead(white);
  greenState = digitalRead(green);
  redState = digitalRead(red);
  yellowState = digitalRead(yellow);

   if (blueState == HIGH) {
    
    scrollText("I Need Help");
  } 

  else if(whiteState==HIGH)
  {
   scrollText("May I Know the Direction/Route"); 
  } 

  else if(greenState==HIGH)
  {
   scrollText("Thank you for the Help"); 
  }

   else if(redState==HIGH)
  {
   scrollText("Emergency"); 
  }

   else if(yellowState==HIGH)
  {
   scrollText("Give me a Glass of Water"); 
  }


  else
   {
     scrollText(".");
  }

  
}

